<template>
    <div class="d-inline-block">
        <slot :events="{ destroy }" :data="{ loading }">
            <i class="fa fa-trash action red fa-lg pointer" @click="showModal">
                <modal v-model="isModalOpen" :footer="false" :header="false">
                    <confirm-form class="px-3" compare-str="1" @on-valid="destroy"/>
                </modal>
            </i>
        </slot>
    </div>
</template>

<script lang="ts">
    import BaseCrudBtn from '../../common/crud/BaseCrudBtn'
    import Component from 'vue-class-component'
    import { Prop } from 'vue-property-decorator'
    import DeleteInterface from '../../../interfaces/common/crud/DeleteInterface'
    import ConfirmForm from '../helpers/ConfirmForm.vue'

    @Component({
        components: {
            ConfirmForm
        }
    })
    export default class DeleteBtn extends BaseCrudBtn implements DeleteInterface {
        @Prop({ required: true }) id!: number

        destroy() {
            this.loading = true

            this.http.delete(
                this.route,
                this.id,
                (res) => {
                    this.$emit('success', res)
                    this.loading = false
                    this.alert.success('Success')
                    this.closeModal()
                },
                (err) => {
                    this.$emit('error', err)
                    this.alert.error('Error')
                }
            )
        }
    }
</script>